#include <iostream>

using namespace std;

int main()
{
    int n,br=0,maks=0;
    cin>>n;
    int x[n+1];
    int y[n+1];
    for(int i=1;i<n;i++){
        cin>>x[i];
        cin>>y[i];
        if(y[i]<x[i]){
            swap(y[i],x[i]);
        }
    }
    for(int i=1;i<n;i++){
    for(int j=1;j<i;j++){
     if(y[i]<y[j]){
        swap(y[i],y[j]);
        swap(x[i],x[j]);
     }
    }
    }
    if(y[1]+1==x[2] && y[2]==x[3]){
        maks=n-1;
        br=1;
    }else{
        maks=n-4;
    br=3;
    }
    if(br+n%2>3){
    cout<<maks;
}
else{
    maks-1;
}
}